<?php
namespace Drupal\miniorange_2fa\form;

use Drupal\user\Entity\User;
use Drupal\Core\Form\FormBase;
use Drupal\miniorange_2fa\MiniorangeUser;
use Drupal\miniorange_2fa\UsersAPIHandler;
use Drupal\miniorange_2fa\MoAuthUtilities;
use Drupal\miniorange_2fa\AuthenticationType;
use Drupal\miniorange_2fa\AuthenticationAPIHandler;
use Drupal\miniorange_2fa\MiniorangeCustomerProfile;

class configure_kba extends FormBase
{
    public function getFormId() {
        return 'miniorange_configure_kba';
    }
    public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state)
    {
        $form['markup_library'] = array(
            '#attached' => array(
                'library' => 'miniorange_2fa/miniorange_2fa.admin',
                'library' => 'miniorange_2fa/miniorange_2fa.license',

            ),
        );

        global $base_url;
        $url = $base_url . '/admin/config/people/miniorange_2fa/setup_twofactor';
        $user = User::load(\Drupal::currentUser()->id());
        $user_id = $user->id();
        $utilities = new MoAuthUtilities();
        $custom_attribute = $utilities::get_users_custom_attribute($user_id);
        $user_email = $custom_attribute[0]->miniorange_registered_email;

        $customer = new MiniorangeCustomerProfile();
        $miniorange_user = new MiniorangeUser($customer->getCustomerID(), $user_email, NULL, NULL, AuthenticationType::$GOOGLE_AUTHENTICATOR['code']);
        $auth_api_handler = new AuthenticationAPIHandler($customer->getCustomerID(), $customer->getAPIKey());

        $form['markup_top_2'] = array(
            '#markup' => '<div class="mo_saml_table_layout_1"><div class="mo_saml_table_layout mo_saml_container">'
        );

        $form['header']['#markup'] = '<div class="mo2f-setup-header"><div class="mo2f-setup-header-top-left">Configure Security Questions (KBA)</div></div>';

        $form['markup_free1'] = array(
            '#markup' =>'<div class="mo2f-info">Please choose 3 questions:</div>
  			        <div class="mo2f-kba-row">'

        );
        $form['mo2f_kbaquestion1'] = array(
            '#type' => 'select',
            '#title' => $this->t('1. Question :'),
            '#options' => array(
                'What is your first company name?' => t('What is your first company name?'),
                'What was your childhood nickname?' => t('What was your childhood nickname?'),
                'In what city did you meet your spouse/significant other?' => t('In what city did you meet your spouse/significant other?'),
                'What is the name of your favorite childhood friend?' => t('What is the name of your favorite childhood friend?'),
                'What school did you attend for sixth grade?' => t('What school did you attend for sixth grade?'),
                'In what city or town was your first job?' => t('In what city or town was your first job?'),
                'What is your favourite sport?' => t('What is your favourite sport?'),
                'Who is your favourite sports player?' => t('Who is your favourite sports player?'),
                'What is your grandmothers maiden name?' => t('What is your grandmothers maiden name?'),
                'What was your first vehicle registration number?' => t('What was your first vehicle registration number?'),
            ),
        );

        $form['mo2f_kbaanswer1'] = array(
            '#type' => 'textfield',
            '#title' => t('Answer : '),
            '#size' => 49,
            '#attributes' => array('placeholder' => t('Enter your answer'),),
            '#suffix' => '</div><br><div class="mo2f-kba-row">',
        );

        $form['mo2f_kbaquestion2'] = array(
            '#type' => 'select',
            '#title' => $this->t('2. Question :'),
            '#options' => array(
                'What is your first company name?' => t('What is your first company name?'),
                'What was your childhood nickname?' => t('What was your childhood nickname?'),
                'In what city did you meet your spouse/significant other?' => t('In what city did you meet your spouse/significant other?'),
                'What is the name of your favorite childhood friend?' => t('What is the name of your favorite childhood friend?'),
                'What school did you attend for sixth grade?' => t('What school did you attend for sixth grade?'),
                'In what city or town was your first job?' => t('In what city or town was your first job?'),
                'What is your favourite sport?' => t('What is your favourite sport?'),
                'Who is your favourite sports player?' => t('Who is your favourite sports player?'),
                'What is your grandmothers maiden name?' => t('What is your grandmothers maiden name?'),
                'What was your first vehicle registration number?' => t('What was your first vehicle registration number?'),
            ),
        );

        $form['mo2f_kbaanswer2'] = array(
            '#type' => 'textfield',
            '#title' => t('Answer : '),
            '#size' => 49,
            '#attributes' => array('placeholder' => t('Enter your answer'),),
            '#suffix' => '</div><br><div class="mo2f-kba-row">',
        );

        $form['mo2f_kbaquestion3'] = array(
            '#type' => 'textfield',
            '#title' => t('3. Question : '),
            '#size' => 49,
            '#attributes' => array('placeholder' => t('Enter your custom question'),),
        );

        $form['mo2f_kbaanswer3'] = array(
            '#type' => 'textfield',
            '#title' => t('Answer : '),
            '#size' => 49,
            '#attributes' => array('placeholder' => t('Enter your answer'),),
            '#suffix' => '<br>',
        );

        $form['actions']['submit'] = array(
            '#type' => 'submit',
            '#value' => t('Save'),
        );

        $form['actions']['cancel'] = array(
            '#markup' => '<span>&nbsp;&nbsp;&nbsp;&nbsp;</span><a href=" '.$url.' ">Cancel</a>',
        );

        $form['main_layout_div_end'] = array(
            '#markup' => '<br><br></div></div>',
        );

        MoAuthUtilities::AddsupportTab($form, $form_state);

        return $form;
    }

    public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {

        $form_state->setRebuild();
        $input = $form_state->getUserInput();

        $user = User::load(\Drupal::currentUser()->id());
        $user_id = $user->id();
        $utilities = new MoAuthUtilities();
        $custom_attribute = $utilities::get_users_custom_attribute($user_id);
        $user_email = $custom_attribute[0]->miniorange_registered_email;
        $ques1 = $input['mo2f_kbaquestion1'];
        $ans1 = $input['mo2f_kbaanswer1'];

        $ques2 = $input['mo2f_kbaquestion2'];
        $ans2 = $input['mo2f_kbaanswer2'];

        $ques3 = $input['mo2f_kbaquestion3'];
        $ans3 = $input['mo2f_kbaanswer3'];

        if(empty($ques1) || empty($ques2) || empty($ques3)|| empty($ans1) || empty($ans2) || empty($ans3)){
            \Drupal::messenger()->addMessage(t('All the questions are mandatory.'), 'error');
            return;
        }elseif ($ques1 == $ques2 || $ques1 == $ques3 || $ques2 == $ques3) {
            \Drupal::messenger()->addMessage(t('The questions you select must not be same.'), 'error');
            return;
        }
        $qa1 = array(
            "question" => $ques1,
            "answer" => $ans1,
        );

        $qa2 = array(
            "question" => $ques2,
            "answer" => $ans2,
        );

        $qa3 = array(
            "question" => $ques3,
            "answer" => $ans3,
        );

        $kba = array($qa1, $qa2, $qa3);

        $customer = new MiniorangeCustomerProfile();
        $miniorange_user = new MiniorangeUser($customer->getCustomerID(), $user_email, NULL, NULL, AuthenticationType::$KBA['code']);
        $auth_api_handler = new AuthenticationAPIHandler($customer->getCustomerID(), $customer->getAPIKey());
        $response = $auth_api_handler->register($miniorange_user, AuthenticationType::$KBA['code'], NULL, NULL, $kba);

        // Clear all the messages
      \Drupal::messenger()->deleteAll();
        // read API response
        if ($response->status == 'SUCCESS') {
          \Drupal::messenger()->addMessage(t(''), 'status');
            $configured_methods = MoAuthUtilities::mo_auth_get_configured_methods($user_id);

            if (!in_array(AuthenticationType::$KBA['code'], $configured_methods)) {
                array_push($configured_methods, AuthenticationType::$KBA['code']);
            }
            $config_methods = implode(', ',$configured_methods);
            $user_api_handler = new UsersAPIHandler($customer->getCustomerID(), $customer->getAPIKey());
            $response = $user_api_handler->update($miniorange_user);
            if ($response->status == 'SUCCESS') {
                // Save User
                $user_id = $user->id();
                $utilities = new MoAuthUtilities();
                $available = $utilities::check_for_userID($user_id);
                $database = \Drupal::database();
                if($available == TRUE) {
                    $database->update('UserAuthenticationType')->fields(['activated_auth_methods'=> AuthenticationType::$KBA['code']])->condition('uid', $user_id,'=')->execute();
                    $database->update('UserAuthenticationType')->fields(['configured_auth_methods'=> $config_methods])->condition('uid', $user_id,'=')->execute();
                }else {
                    echo "error while saving authentication method.";exit;
                }

                $message = 'KBA Authentication configured successfully.';
                MoAuthUtilities::show_error_or_success_message($message , 'status');
            }
        } elseif ($response->status == 'FAILED') {
            $message = 'An error occured while configuring KBA Authentication. Please try again.';
            MoAuthUtilities::show_error_or_success_message($message , 'error');
        } else {
            $message = 'An error occured while processing your request. Please try again.';
            MoAuthUtilities::show_error_or_success_message($message , 'error');
        }

    }
}
